// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from OverCurrentProtector.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface OverCurrentProtector_4_0_1 extends com.raritan.idl.pdumodel.EDevice_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OverCurrentProtector:4.0.1", com.raritan.idl.pdumodel.EDevice_1_0_1.typeInfo);

  public enum Type {
    BREAKER_1POLE,
    BREAKER_2POLE,
    BREAKER_3POLE,
    FUSE,
    FUSE_PAIR,
    RCBO_2POLE,
    RCBO_3POLE,
    RCBO_4POLE;
  }

  static public class MetaData implements Cloneable {
    public String label = new String();
    public com.raritan.idl.pdumodel.Nameplate_2_0_0 namePlate = new com.raritan.idl.pdumodel.Nameplate_2_0_0();
    public com.raritan.idl.pdumodel.Rating_2_0_0 rating = new com.raritan.idl.pdumodel.Rating_2_0_0();
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Type type = com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Type.values()[0];
    public int maxTripCnt = 0;

    public Object clone() {
      MetaData copy = new MetaData();

      copy.label = this.label;
      Object namePlateCopy = this.namePlate.clone();
      copy.namePlate = (com.raritan.idl.pdumodel.Nameplate_2_0_0) namePlateCopy;
      Object ratingCopy = this.rating.clone();
      copy.rating = (com.raritan.idl.pdumodel.Rating_2_0_0) ratingCopy;
      copy.type = this.type;
      copy.maxTripCnt = this.maxTripCnt;

      return copy;
    }

  }

  static public class Sensors implements Cloneable {
    public com.raritan.idl.sensors.StateSensor_4_0_5 trip = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 voltage = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 current = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 peakCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 maximumCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 activePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 reactivePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 apparentPower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 powerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 displacementPowerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 crestFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 activeEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 apparentEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 phaseAngle = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 lineFrequency = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 residualCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 residualACCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_6 residualDCCurrent = null;
    public com.raritan.idl.pdumodel.ResidualCurrentStateSensor_2_0_5 residualCurrentStatus = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.trip = this.trip;
      copy.voltage = this.voltage;
      copy.current = this.current;
      copy.peakCurrent = this.peakCurrent;
      copy.maximumCurrent = this.maximumCurrent;
      copy.activePower = this.activePower;
      copy.reactivePower = this.reactivePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.displacementPowerFactor = this.displacementPowerFactor;
      copy.crestFactor = this.crestFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.apparentEnergy = this.apparentEnergy;
      copy.phaseAngle = this.phaseAngle;
      copy.lineFrequency = this.lineFrequency;
      copy.residualCurrent = this.residualCurrent;
      copy.residualACCurrent = this.residualACCurrent;
      copy.residualDCCurrent = this.residualDCCurrent;
      copy.residualCurrentStatus = this.residualCurrentStatus;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;

      return copy;
    }

  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OverCurrentProtector_4_0_1.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings oldSettings = new com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings();
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings newSettings = new com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings();
  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.DoublePole_8_0_0> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  public class GetInletResult {
    public com.raritan.idl.pdumodel.Inlet_3_0_1 _ret_;
  }

  GetInletResult getInlet() throws Exception;

  AsyncRequest getInlet(AsyncRpcResponse<GetInletResult> rsp);

  AsyncRequest getInlet(AsyncRpcResponse<GetInletResult> rsp, RpcCtrl rpcCtrl);


  public class GetOCPResult {
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1 _ret_;
  }

  GetOCPResult getOCP() throws Exception;

  AsyncRequest getOCP(AsyncRpcResponse<GetOCPResult> rsp);

  AsyncRequest getOCP(AsyncRpcResponse<GetOCPResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OverCurrentProtector_4_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

}
