// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from NumericSensor.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface NumericSensor_4_0_0 extends com.raritan.idl.sensors.Sensor_4_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor:4.0.0", com.raritan.idl.sensors.Sensor_4_0_0.typeInfo);

  public static final int THRESHOLD_OUT_OF_RANGE = 1;

  public static final int THRESHOLD_INVALID = 2;

  public static final int THRESHOLD_NOT_SUPPORTED = 3;

  static public class Range implements Cloneable {
    public double lower = 0.0;
    public double upper = 0.0;

    public Object clone() {
      Range copy = new Range();

      copy.lower = this.lower;
      copy.upper = this.upper;

      return copy;
    }

  }

  static public class ThresholdCapabilities implements Cloneable {
    public boolean hasUpperCritical = false;
    public boolean hasUpperWarning = false;
    public boolean hasLowerWarning = false;
    public boolean hasLowerCritical = false;

    public Object clone() {
      ThresholdCapabilities copy = new ThresholdCapabilities();

      copy.hasUpperCritical = this.hasUpperCritical;
      copy.hasUpperWarning = this.hasUpperWarning;
      copy.hasLowerWarning = this.hasLowerWarning;
      copy.hasLowerCritical = this.hasLowerCritical;

      return copy;
    }

  }

  static public class MetaData implements Cloneable {
    public com.raritan.idl.sensors.Sensor_4_0_0.TypeSpec type = new com.raritan.idl.sensors.Sensor_4_0_0.TypeSpec();
    public int decdigits = 0;
    public float accuracy = 0.0f;
    public float resolution = 0.0f;
    public float tolerance = 0.0f;
    public float noiseThreshold = 0.0f;
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Range range = new com.raritan.idl.sensors.NumericSensor_4_0_0.Range();
    public com.raritan.idl.sensors.NumericSensor_4_0_0.ThresholdCapabilities thresholdCaps = new com.raritan.idl.sensors.NumericSensor_4_0_0.ThresholdCapabilities();

    public Object clone() {
      MetaData copy = new MetaData();

      Object typeCopy = this.type.clone();
      copy.type = (com.raritan.idl.sensors.Sensor_4_0_0.TypeSpec) typeCopy;
      copy.decdigits = this.decdigits;
      copy.accuracy = this.accuracy;
      copy.resolution = this.resolution;
      copy.tolerance = this.tolerance;
      copy.noiseThreshold = this.noiseThreshold;
      Object rangeCopy = this.range.clone();
      copy.range = (com.raritan.idl.sensors.NumericSensor_4_0_0.Range) rangeCopy;
      Object thresholdCapsCopy = this.thresholdCaps.clone();
      copy.thresholdCaps = (com.raritan.idl.sensors.NumericSensor_4_0_0.ThresholdCapabilities) thresholdCapsCopy;

      return copy;
    }

  }

  static public class Thresholds implements Cloneable {
    public boolean upperCriticalActive = false;
    public double upperCritical = 0.0;
    public boolean upperWarningActive = false;
    public double upperWarning = 0.0;
    public boolean lowerWarningActive = false;
    public double lowerWarning = 0.0;
    public boolean lowerCriticalActive = false;
    public double lowerCritical = 0.0;
    public int assertionTimeout = 0;
    public float deassertionHysteresis = 0.0f;

    public Object clone() {
      Thresholds copy = new Thresholds();

      copy.upperCriticalActive = this.upperCriticalActive;
      copy.upperCritical = this.upperCritical;
      copy.upperWarningActive = this.upperWarningActive;
      copy.upperWarning = this.upperWarning;
      copy.lowerWarningActive = this.lowerWarningActive;
      copy.lowerWarning = this.lowerWarning;
      copy.lowerCriticalActive = this.lowerCriticalActive;
      copy.lowerCritical = this.lowerCritical;
      copy.assertionTimeout = this.assertionTimeout;
      copy.deassertionHysteresis = this.deassertionHysteresis;

      return copy;
    }

  }

  static public class Reading implements Cloneable {

    static public class Status implements Cloneable {
      public boolean aboveUpperCritical = false;
      public boolean aboveUpperWarning = false;
      public boolean belowLowerWarning = false;
      public boolean belowLowerCritical = false;

      public Object clone() {
        Status copy = new Status();

        copy.aboveUpperCritical = this.aboveUpperCritical;
        copy.aboveUpperWarning = this.aboveUpperWarning;
        copy.belowLowerWarning = this.belowLowerWarning;
        copy.belowLowerCritical = this.belowLowerCritical;

        return copy;
      }

    }
    public java.util.Date timestamp = new java.util.Date();
    public boolean available = false;
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Reading.Status status = new com.raritan.idl.sensors.NumericSensor_4_0_0.Reading.Status();
    public boolean valid = false;
    public double value = 0.0;

    public Object clone() {
      Reading copy = new Reading();

      copy.timestamp = this.timestamp;
      copy.available = this.available;
      Object statusCopy = this.status.clone();
      copy.status = (com.raritan.idl.sensors.NumericSensor_4_0_0.Reading.Status) statusCopy;
      copy.valid = this.valid;
      copy.value = this.value;

      return copy;
    }

  }

  public class ReadingChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_0.ReadingChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_0.Reading newReading = new com.raritan.idl.sensors.NumericSensor_4_0_0.Reading();
  }

  public class StateChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_0.StateChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_0.Reading oldReading = new com.raritan.idl.sensors.NumericSensor_4_0_0.Reading();
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Reading newReading = new com.raritan.idl.sensors.NumericSensor_4_0_0.Reading();
  }

  public class MetaDataChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_0.MetaDataChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_0.MetaData oldMetaData = new com.raritan.idl.sensors.NumericSensor_4_0_0.MetaData();
    public com.raritan.idl.sensors.NumericSensor_4_0_0.MetaData newMetaData = new com.raritan.idl.sensors.NumericSensor_4_0_0.MetaData();
  }

  public class ThresholdsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.NumericSensor_4_0_0.ThresholdsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds oldThresholds = new com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds();
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds newThresholds = new com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds();
  }

  public class GetMetaDataResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_0.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetDefaultThresholdsResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds _ret_;
  }

  GetDefaultThresholdsResult getDefaultThresholds() throws Exception;

  AsyncRequest getDefaultThresholds(AsyncRpcResponse<GetDefaultThresholdsResult> rsp);

  AsyncRequest getDefaultThresholds(AsyncRpcResponse<GetDefaultThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class GetThresholdsResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds _ret_;
  }

  GetThresholdsResult getThresholds() throws Exception;

  AsyncRequest getThresholds(AsyncRpcResponse<GetThresholdsResult> rsp);

  AsyncRequest getThresholds(AsyncRpcResponse<GetThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class SetThresholdsResult {
    public int _ret_;
  }

  SetThresholdsResult setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds thresh) throws Exception;

  AsyncRequest setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds thresh, AsyncRpcResponse<SetThresholdsResult> rsp);

  AsyncRequest setThresholds(com.raritan.idl.sensors.NumericSensor_4_0_0.Thresholds thresh, AsyncRpcResponse<SetThresholdsResult> rsp, RpcCtrl rpcCtrl);


  public class GetReadingResult {
    public com.raritan.idl.sensors.NumericSensor_4_0_0.Reading _ret_;
  }

  GetReadingResult getReading() throws Exception;

  AsyncRequest getReading(AsyncRpcResponse<GetReadingResult> rsp);

  AsyncRequest getReading(AsyncRpcResponse<GetReadingResult> rsp, RpcCtrl rpcCtrl);

}
