// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from SerialPort.idl.

package com.raritan.idl.serial;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface SerialPort_2_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("serial.SerialPort:2.0.0", null);

  public static final int SUCCESS = 0;

  public static final int ERR_INVALID_VALUE = 1;

  public enum PortState {
    CONSOLE,
    ANALOGMODEM,
    GSMMODEM;
  }

  public enum BaudRate {
    BR1200,
    BR2400,
    BR4800,
    BR9600,
    BR19200,
    BR38400,
    BR57600,
    BR115200;
  }

  static public class State implements Cloneable {
    public com.raritan.idl.serial.SerialPort_2_0_0.PortState state = com.raritan.idl.serial.SerialPort_2_0_0.PortState.values()[0];
    public String deviceName = new String();

    public Object clone() {
      State copy = new State();

      copy.state = this.state;
      copy.deviceName = this.deviceName;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public com.raritan.idl.serial.SerialPort_2_0_0.BaudRate consoleBaudRate = com.raritan.idl.serial.SerialPort_2_0_0.BaudRate.values()[0];
    public com.raritan.idl.serial.SerialPort_2_0_0.BaudRate modemBaudRate = com.raritan.idl.serial.SerialPort_2_0_0.BaudRate.values()[0];

    public Object clone() {
      Settings copy = new Settings();

      copy.consoleBaudRate = this.consoleBaudRate;
      copy.modemBaudRate = this.modemBaudRate;

      return copy;
    }

  }

  public class ModemEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("serial.SerialPort_2_0_0.ModemEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public Object modem = null;
  }

  public class ModemAddedEvent extends com.raritan.idl.serial.SerialPort_2_0_0.ModemEvent {

    static public final TypeInfo typeInfo = new TypeInfo("serial.SerialPort_2_0_0.ModemAddedEvent:1.0.0", com.raritan.idl.serial.SerialPort_2_0_0.ModemEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class ModemRemovedEvent extends com.raritan.idl.serial.SerialPort_2_0_0.ModemEvent {

    static public final TypeInfo typeInfo = new TypeInfo("serial.SerialPort_2_0_0.ModemRemovedEvent:1.0.0", com.raritan.idl.serial.SerialPort_2_0_0.ModemEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class GetSettingsResult {
    public com.raritan.idl.serial.SerialPort_2_0_0.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.serial.SerialPort_2_0_0.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.serial.SerialPort_2_0_0.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.serial.SerialPort_2_0_0.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class GetStateResult {
    public com.raritan.idl.serial.SerialPort_2_0_0.State _ret_;
  }

  GetStateResult getState() throws Exception;

  AsyncRequest getState(AsyncRpcResponse<GetStateResult> rsp);

  AsyncRequest getState(AsyncRpcResponse<GetStateResult> rsp, RpcCtrl rpcCtrl);


  public class GetModemResult {
    public Object _ret_;
  }

  GetModemResult getModem() throws Exception;

  AsyncRequest getModem(AsyncRpcResponse<GetModemResult> rsp);

  AsyncRequest getModem(AsyncRpcResponse<GetModemResult> rsp, RpcCtrl rpcCtrl);

}
