// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Smtp.idl.

package com.raritan.json_rpc.devsettings;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Smtp_Proxy extends ObjectProxy implements com.raritan.idl.devsettings.Smtp {

  public Smtp_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Smtp_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.devsettings.Smtp.typeInfo);
  }

  public static Smtp_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Smtp_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetConfigurationResult getConfiguration() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getConfiguration", params);
    GetConfigurationResult ret = new GetConfigurationResult();
    ret._ret_ = com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getConfiguration(final AsyncRpcResponse<GetConfigurationResult> rsp) {
    return getConfiguration(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getConfiguration(final AsyncRpcResponse<GetConfigurationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getConfiguration", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetConfigurationResult ret = new GetConfigurationResult();
          ret._ret_ = com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void setConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg) throws Exception {
    JSONObject params = new JSONObject();
    params.put("cfg", com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.encode(cfg));
    rpcCall("setConfiguration", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest setConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg, final AsyncRpcResponse<Void> rsp) {
    return setConfiguration(cfg, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("cfg", com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.encode(cfg));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setConfiguration", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public TestConfigurationResult testConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg, final java.util.List<String> recipients) throws Exception {
    JSONObject params = new JSONObject();
    params.put("cfg", com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.encode(cfg));
    params.put("recipients", new JSONArray() {{
      final java.util.List<String> array0 = recipients;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    final JSONObject result = rpcCall("testConfiguration", params);
    TestConfigurationResult ret = new TestConfigurationResult();
    ret._ret_ = com.raritan.json_rpc.devsettings.Smtp.TestResult_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest testConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg, final java.util.List<String> recipients, final AsyncRpcResponse<TestConfigurationResult> rsp) {
    return testConfiguration(cfg, recipients, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest testConfiguration(final com.raritan.idl.devsettings.Smtp.Configuration cfg, final java.util.List<String> recipients, final AsyncRpcResponse<TestConfigurationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("cfg", com.raritan.json_rpc.devsettings.Smtp.Configuration_Codec.encode(cfg));
      params.put("recipients", new JSONArray() {{
        final java.util.List<String> array0 = recipients;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("testConfiguration", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          TestConfigurationResult ret = new TestConfigurationResult();
          ret._ret_ = com.raritan.json_rpc.devsettings.Smtp.TestResult_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
